/************************** (C) COPYRIGHT 2015 Classys **************************
* File Name       : 
* Author            : CLASSYS
* Version          : Ver 0.1
* Date               : 2016/04/12
* Description    : 
*
* Revision History
* Date          Version       Name          					Description
* 2016/04/12  	0.1          Oanny        					Proto.
*******************************************************************************/

#include "usr_ssd13xx.h"

#define Interface_SPI 
	
sbit	LCM_DC		=	P1^3;
//sbit	LCM_CS		=	P3^3;
//sbit	LCM_RES	=	P3^3; //RST

#ifdef  Interface_8080

sbit	LCM_CS		=	P3^3;

sbit	LCM_RD		=	P3^1;
sbit	LCM_WR	=	P3^0;

#define		Data_BUS	P0
#define		MODE8080	//MODE6800
/*******************************************************************************
* Function Name : 
* Description   :
* Parameters    : 
* Return        : None
*******************************************************************************/
void Write_Cmd(u8 cmd)
{
   LCM_CS = low;
   LCM_DC = low;
   LCM_WR = low;
   _nop_();_nop_();
   Data_BUS = cmd;
   LCM_WR = high;
   _nop_();_nop_();
   LCM_CS = high;
}

/*******************************************************************************
* Function Name : 
* Description   :
* Parameters    : 
* Return        : None
*******************************************************************************/
void Write_Cmd_2nd(u8 cmd){
	Data_BUS = cmd;

#if defined MODE8080
	LCM_DC = 0;
	
	LCM_CS = 0;
	LCM_WR = 0;

	LCM_WR = 1;
	LCM_CS = 1;
	LCM_DC = 1;
#elif defined MODE6800
	LCM_CS = 0;
	LCM_DC = 0;
	LCM_RW = 0;
	
	LCM_EN = 1;
	_nop_();
	LCM_EN = 0;
#endif
}

/*******************************************************************************
* Function Name : 
* Description   :
* Parameters    : 
* Return        : None
*******************************************************************************/
void Write_Data(u8 dat)
{
   LCM_CS = low;
   LCM_DC = high;
   LCM_WR = low;
   _nop_();_nop_();
   Data_BUS = dat;
   LCM_WR = high;
   _nop_();_nop_();
   LCM_CS = high;
}

/*******************************************************************************
* Function Name : 
* Description   :
* Parameters    : 
* Return        : None
*******************************************************************************/
void Write_Data_2nd(u8 dat){
	Data_BUS = dat;
	
#if defined MODE8080
	LCM_DC = 1;
	LCM_CS = 0;
	LCM_WR = 0;
	
	LCM_WR = 1;
	LCM_CS = 1;
	LCM_DC = 1;
#elif defined MODE6800

	LCM_CS = 0;
	LCM_DC = 1;
	LCM_RW = 0;
	
	LCM_EN = 1;
	_nop_();
	LCM_EN = 0;
#endif
}

/*******************************************************************************
* Function Name : 
* Description   :
* Parameters    : 
* Return        : None
*******************************************************************************/
u8 Read_Data(void)
{
	u8 dataReturn;
	
#if defined MODE8080
	LCM_DC = 1;
	
	LCM_RD = 0;
	
	LCM_CS = 0;
	_nop_();
	dataReturn = Data_BUS;
	LCM_CS = 1;
	
	LCM_RD = 1;
	LCM_DC = 1;
#elif defined MODE6800
	LCM_CS = 0;
	LCM_DC = 1;
	LCM_RW = 0;
	
	LCM_EN = 1;
	_nop_();
	dataReturn = Data_BUS;
	LCM_EN = 0;
#endif

	return dataReturn;
}

#endif

#ifdef  Interface_SPI_Manual

sbit	LCM_CS		=	P3^3;

sbit 	LCM_SDI	=	P3^5;				// Serial Data Input p34
sbit 	LCM_SCL =	P3^6;				// Serial Clock Input p36
/*******************************************************************************
* Function Name : 
* Description   :
* Parameters    : 
* Return        : None
*******************************************************************************/
void Write_Cmd(u8 cmd)
{
	u8 i, value;
	value = cmd;

	LCM_CS = low;
	LCM_DC = low;

	for(i=0; i<8; i++)
	{
		LCM_SCL = low;

		_nop_(); _nop_();

		if(value & 0x80) LCM_SDI = high;
		else  LCM_SDI = low;

		LCM_SCL = high;
		_nop_(); _nop_();

		value =  value<<1;//_crol_(value, 1);
	}

	LCM_CS = high;
}

/*******************************************************************************
* Function Name : 
* Description   :
* Parameters    : 
* Return        : None
*******************************************************************************/
void Write_Data(u8 dat)
{
	u8 i, value;
	value = dat;
	
	LCM_CS = low;
	LCM_DC = high;

	for(i=0; i<8; i++)
	{
		LCM_SCL = low;
		_nop_(); _nop_();

		if(value & 0x80) LCM_SDI = high;
		else  LCM_SDI = low;

		LCM_SCL = high;
		_nop_(); _nop_();

		value =  value<<1; //_crol_(value, 1); //shift <<
	}
	
	LCM_CS = high;
}
#endif

#ifdef  Interface_SPI
/*******************************************************************************
* Function Name : 
* Description   :
* Parameters    : 
* Return        : None
*******************************************************************************/
void Write_Cmd(u8 cmd)
{
	LCM_DC = low;

	SYS_SpiMasterPut(1, cmd);
}

/*******************************************************************************
* Function Name : 
* Description   :
* Parameters    : 
* Return        : None
*******************************************************************************/
void Write_Data(u8 dat)
{
	LCM_DC = high;

	SYS_SpiMasterPut(1, dat);
}
#endif

/*******************************************************************************
* Function Name : 
* Description   :
* Parameters    : 
* Return        : None
*******************************************************************************/
void Reset_SSD13xx()
{
	_nop_(); _nop_();//	AppLib_Delay(10);
//	LCM_RES = low;

	_nop_(); _nop_();//	AppLib_Delay(50);
//	LCM_RES = high;
}

#ifdef  USE_SSD1305
/*******************************************************************************
* Function Name : 
* Description   :
* Parameters    : 
* Return        : None
*******************************************************************************/
void Init_SSD1305()
{
   Reset_SSD13xx();

	HAL_Gpio1InOutSet(3, GPIO_OUTPUT, GPIO_DRIVE_4mA);	GP13 = 0;/* DC */
	HAL_Gpio3InOutSet(3, GPIO_OUTPUT, GPIO_DRIVE_4mA);	GP33 = 0;/* CS */

#ifdef  Interface_SPI_Manual
HAL_Gpio3InOutSet(5, GPIO_OUTPUT, GPIO_DRIVE_4mA);	GP35 = 0;/* SDO */
HAL_Gpio3InOutSet(6, GPIO_OUTPUT, GPIO_DRIVE_4mA);	GP36 = 0;/* SCK */
#endif	

#ifdef  Interface_SPI
	HAL_SpiClockOn(on);
	HAL_SpiIntSet(ENABLE, PRIORITY_LOW, SPI_MASTER | SPI_POLARITY_HIGH | SPI_PHASE_1ST, SPI_SPEED_1MHz);
#endif	
	
   Write_Cmd(0xae);
  
   Write_Cmd(0xa1);    //segment remap

   Write_Cmd(0xda);    //common pads hardware: alternative
   Write_Cmd(0x12);

   Write_Cmd(0xc8);    //common output scan direction:com63~com0

   Write_Cmd(0xa8);    //multiplex ration mode:63
   Write_Cmd(0x3f);

   Write_Cmd(0xd5);    //display divide ratio/osc. freq. mode
   Write_Cmd(0x50);    //Osc. Freq:320kHz,DivideRation:1

   Write_Cmd(0x81);    //contrast control 
   Write_Cmd(0x80);    // mode:64

   Write_Cmd(0xd9);	   //set pre-charge period
   Write_Cmd(0xf1);	   //set period 1:1;period 2:15

   Write_Cmd(0x20);    //Set Memory Addressing Mode
   Write_Cmd(0x02);    //page addressing mode

   Write_Cmd(0xdb);    //VCOM deselect level mode

   Write_Cmd(0x3c);	   //set Vvcomh=0.83*Vcc

   Write_Cmd(0xad);    //master configuration 

   Write_Cmd(0x8e);    //external VCC supply

   Write_Cmd(0xa4);    //out follows RAM content

   Write_Cmd(0xa6);    //set normal display

   Write_Cmd(0xaf);
}
#endif

/*******************************************************************************
* Function Name : 
* Description   :
* Parameters    : 
* Return        : None
*******************************************************************************/
void Init_SSD1325(void)
{
  Reset_SSD13xx();

	HAL_Gpio1InOutSet(3, GPIO_OUTPUT, GPIO_DRIVE_4mA);	GP13 = 0;/* DC */
	HAL_Gpio3InOutSet(3, GPIO_OUTPUT, GPIO_DRIVE_4mA);	GP33 = 0;/* CS */

#ifdef  Interface_SPI_Manual
HAL_Gpio3InOutSet(5, GPIO_OUTPUT, GPIO_DRIVE_4mA);	GP35 = 0;/* SDO */
HAL_Gpio3InOutSet(6, GPIO_OUTPUT, GPIO_DRIVE_4mA);	GP36 = 0;/* SCK */
#endif	

#ifdef  Interface_SPI
	HAL_SpiClockOn(on);
	HAL_SpiIntSet(ENABLE, PRIORITY_LOW, SPI_MASTER | SPI_POLARITY_HIGH | SPI_PHASE_1ST, SPI_SPEED_1MHz);
#endif	
	
	Set_Display_On_Off(0x00);		// Display Off (0x00/0x01)
	Set_Display_Clock(0x91);		// Set Clock as 135 Frames/Sec
	Set_Multiplex_Ratio(0x3F);		// 1/64 Duty (0x0F~0x5F)
	Set_Display_Offset(0x00);		// Shift Mapping RAM Counter (0x00~0x5F)
	Set_Start_Line(0x00);			// Set Mapping RAM Display Start Line (0x00~0x5F)
	Set_Master_Config(0x00);		// Disable Embedded DC/DC Converter (0x00/0x01)
	Set_Remap_Format(0x40);			// Set Column Address 0 Mapped to SEG0
						//     Disable Nibble Remap
						//     Horizontal Address Increment
						//     Scan from COM[N-1] to COM0
						//     Enable COM Split Odd Even
	Set_Current_Range(0x02);		// Set Full Current Range
	Set_Gray_Scale_Table();			// Set Pulse Width for Gray Scale Table
	Set_Contrast_Current(Brightness);	// Set Scale Factor of Segment Output Current Control
	Set_Frame_Frequency(0x51);		// Set Frame Frequency
	Set_Phase_Length(0x55);			// Set Phase 1 as 5 Clocks & Phase 2 as 5 Clocks
	Set_Precharge_Voltage(0x10);		// Set Pre-Charge Voltage Level
	Set_Precharge_Compensation(0x20,0x02);	// Set Pre-Charge Compensation
	Set_VCOMH(0x1C);			// Set High Voltage Level of COM Pin
	Set_VSL(0x0D);				// Set Low Voltage Level of SEG Pin
	Set_Display_Mode(0x00);			// Normal Display Mode (0x00/0x01/0x02/0x03)

	Fill_RAM(0x00);				// Clear Screen
	AppLib_Delay(10);

	Set_Display_On_Off(0x01);		// Display On (0x00/0x01)
	
}
